"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_shared_1 = require("@dgui/react-shared");
const react_1 = require("react");
const react_router_1 = require("react-router");
const RouteControl = ({ tabId }) => {
    const hasRendered = (0, react_1.useRef)(false);
    const { tabId: routeId } = (0, react_router_1.useParams)();
    const navigate = (0, react_router_1.useNavigate)();
    const location = (0, react_router_1.useLocation)();
    const { tabOrder, tabs } = (0, react_1.useContext)(react_shared_1.TabContext);
    const { tabIndex } = (0, react_1.useContext)(react_shared_1.TabIndexContext);
    const { tabId: selectedTabId, tabPath: selectedTabPath } = (0, react_1.useMemo)(() => {
        return tabs[tabOrder[tabIndex]] || {};
    }, [
        tabIndex,
        tabOrder,
        tabs
    ]);
    (0, react_1.useEffect)(() => {
        if (hasRendered.current &&
            routeId &&
            selectedTabId &&
            tabId === selectedTabId) {
            const indexChange = tabIndex !== tabOrder.indexOf(routeId);
            if (indexChange) {
                const generatedPath = (0, react_router_1.generatePath)(selectedTabPath, {
                    tabId: selectedTabId
                });
                if (!location.pathname.includes(generatedPath)) {
                    navigate('/' + generatedPath, {
                        relative: 'path'
                    });
                }
            }
        }
    }, [
        tabIndex
    ]);
    (0, react_1.useEffect)(() => {
        hasRendered.current = true;
    }, []);
    return null;
};
exports.default = RouteControl;
